// -*-C++-*-
//
// File:      QtRegister.h
// Author:    jbakker
// Generated: Mon Apr 10 14:45:24 MET DST 2000

#ifndef QtRegister_h
#define QtRegister_h

#include "Register.h"
#include <qapplication.h>

namespace Info
{

/*
  Registring of a task to Qt
 */  
class QtRegister : public Register
{
public:
  QtRegister(Task* t) :Register(t), _qApp(0){}
  ~QtRegister() { stop();}

  void start() {
    // create a default Qt application, if non available
    if (! qApp) {
      char** argv=0;
      int    argc=0;
      _qApp=new QApplication(argc,argv);
    }
  }

  void stop() {
    if (_qApp) {
      delete _qApp;
      _qApp=0;
    }
  }
private:
  // member functions
  QtRegister(const QtRegister&);            // copy constructor (disabled)
  QtRegister& operator=(const QtRegister&); // assignment (disabled)

  // member data
  QApplication* _qApp;
};

};

#endif
